/*
 * vdr-podcatcher - A plugin for the Linux Video Disk Recorder
 * Copyright (c) 2006 Tobias Grimm <vdr@e-tobi.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: pesaudiopacket.h 3219 2006-04-16 15:06:35Z svntobi $
 *
 */

#ifndef ___PESAUDIOPACKET_H
#define ___PESAUDIOPACKET_H

#include "refptr.h"

class PesAudioPacket
{
    private:
        int frameSize;
        unsigned char* buffer;
        unsigned char* writePtr;
        unsigned int timeIndex;
        int totalTime;

    private:
        void SetFixedPesHeaderFields();
        void SetPesAudioPacketLength(unsigned short length);
        void SetFixedLpcmHeaderFields();
        void PutData(int offset, const unsigned char* data, int length);
        void PutBigEndianShort(signed int sample);

    public:
        PesAudioPacket(int frameSize);
        virtual ~PesAudioPacket();
        int GetBufferSize();
        unsigned char* GetBufferPtr();
        bool AddSample(signed int left, signed int right);
        void SetTimeIndex(unsigned int index);
        unsigned int GetTimeIndex();
        void SetTotalTime(int time);
        int GetTotalTime();
};

#endif
